import { Character } from "./Character";
import { SlotInfo, StatusInfo } from "./definitions/adventureland";
import { CharacterType, CXData, DamageType, GData2, MapName, NPCName, SkillName } from "./definitions/adventureland-data";
import { PlayerData } from "./definitions/adventureland-server";
import { Entity } from "./Entity";
export declare class Player implements PlayerData {
    protected G: GData2;
    afk?: boolean | "code";
    id: string;
    ctype: CharacterType;
    abs: boolean;
    angle?: number;
    armor: number;
    apiercing: number;
    attack: number;
    avoidance: number;
    cid: number;
    crit: number;
    critdamage: number;
    damage_type: DamageType;
    evasion: number;
    frequency: number;
    going_x?: number;
    going_y?: number;
    level: number;
    move_num: number;
    moving: boolean;
    party: string;
    reflection: number;
    resistance: number;
    rpiercing: number;
    target: string;
    x: number;
    y: number;
    s: StatusInfo;
    c: any;
    cx: CXData;
    focus?: string;
    hp: number;
    max_hp: number;
    max_mp: number;
    mp: number;
    npc?: NPCName;
    owner: string;
    pdps: number;
    q: {
        compound?: {
            len: number;
            ms: number;
            num: number;
            nums: number[];
        };
        upgrade?: {
            len: number;
            ms: number;
            num: number;
        };
    };
    range: number;
    rip: boolean;
    skin: string;
    slots: SlotInfo;
    speed: number;
    stand?: boolean | "cstand" | "stand0";
    tp?: boolean;
    in: MapName;
    map: MapName;
    constructor(data: PlayerData, map: MapName, g: GData2);
    updateData(data: PlayerData): void;
    calculateDamageRange(defender: Entity | Player | Character, skill?: SkillName): [number, number];
    isFriendly(bot: Character): boolean;
    isNPC(): boolean;
}
